#
# Conditional build:
%bcond_without	kernelsrc	# probes which require full kernel source (kvm, btrfs, ext4, regmap)
%bcond_without	ftrace		# dynamic ftrace module
%bcond_with	verbose		# verbose build (V=1)

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		rel	2
%define		pname	lttng-modules
Summary:	LTTng 2.x kernel modules
Summary(pl.UTF-8):	Moduły jądra LTTng 2.x
Name:		%{pname}%{_alt_kernel}
Version:	2.10.7
Release:	%{rel}@%{_kernel_ver_str}
License:	GPL v2
Group:		Base/Kernel
Source0:	http://lttng.org/files/lttng-modules/%{pname}-%{version}.tar.bz2
# Source0-md5:	d3cb4520948083bf1573a2e4cb7406aa
Patch0:		build.patch
Patch1:		kernel-4.19.patch
URL:		http://lttng.org/
%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:2.6.38}
%{?with_kernelsrc:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-source >= 3:2.6.38}}
BuildRequires:	rpmbuild(macros) >= 1.701
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LTTng 2.x kernel modules.

%description -l pl.UTF-8
Moduły jądra LTTng 2.x.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-lttng\
Summary:	LTTng 2.x modules for Linux kernel\
Summary(pl.UTF-8):	Moduły LTTng 2.x dla jądra Linuksa\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-lttng\
LTTng 2.x modules for Linux kernel.\
\
%description -n kernel%{_alt_kernel}-lttng -l pl.UTF-8\
Moduły LTTng 2.x dla jądra Linuksa.\
\
%files -n kernel%{_alt_kernel}-lttng\
%defattr(644,root,root,755)\
%doc ChangeLog LICENSE README.md TODO\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-clock.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-ring-buffer-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-statedump.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-tracer.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/lib\
/lib/modules/%{_kernel_ver}/kernel/lttng/lib/lttng-lib-ring-buffer.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/probes\
%{?with_ftrace:/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-ftrace.ko*}\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kretprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-probe-*.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/tests\
/lib/modules/%{_kernel_ver}/kernel/lttng/tests/lttng-clock-plugin-test.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/tests/lttng-test.ko*\
\
%post	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%{__make} \\\
	KERNELDIR=%{_kernelsrcdir}\
p=`pwd`\
%{__make} modules_install \\\
	INSTALL_MOD_PATH=$p/installed \\\
	INSTALL_MOD_DIR=kernel/lttng \\\
	KERNELDIR=%{_kernelsrcdir}\
%{nil}

%{expand:%create_kernel_packages}

%prep
%setup -q -n %{pname}-%{version}
%patch0 -p1
%patch1 -p1

%build
%{expand:%build_kernel_packages}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT

cp -a installed/* $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT
%changelog
* Sun Dec 30 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lttng-modules.git;a=log;h=auto/th/lttng-modules-2.10.7-2

* Sat Oct 27 2018 Jan Rękorajski <baggins@pld-linux.org> cf47fa9
- fix building with kernel 4.19

* Mon Aug 13 2018 Jan Rękorajski <baggins@pld-linux.org> 616ac20
- up to 2.10.7

* Mon Jun 18 2018 Jan Rękorajski <baggins@pld-linux.org> 7681880
- up to 2.10.6

* Sat Apr 07 2018 Jan Rękorajski <baggins@pld-linux.org> ce7edfe
- upstream fixes for kernel 4.16

* Fri Apr 06 2018 Jan Rękorajski <baggins@pld-linux.org> bb69d75
- up to 2.10.5

* Mon Jan 29 2018 Jan Rękorajski <baggins@pld-linux.org> 9fd8375
- upstream fixes for kernel 4.15
- rel 3

* Fri Jan 19 2018 Jan Rękorajski <baggins@pld-linux.org> b1989bf
- upstream updates for kvm instrumentation
- rel 2

* Thu Nov 16 2017 Jan Rękorajski <baggins@pld-linux.org> 3bb63f3
- up to 2.10.4

* Sat Sep 16 2017 Jan Rękorajski <baggins@pld-linux.org> f6e66b0
- updated to 2.10.0 with upstream fix for kernel 4.13

* Mon Jul 31 2017 Jakub Bogusz <qboosh@pld-linux.org> e3e5646
- updated to 2.9.3

* Wed May 10 2017 Jan Rękorajski <baggins@pld-linux.org> 31ce0d4
- up to 2.9.2

* Sat Mar 25 2017 Jan Rękorajski <baggins@pld-linux.org> a446313
- up to 2.9.1

* Sun Dec 25 2016 Jakub Bogusz <qboosh@pld-linux.org> a48baa1
- updated to 2.9.0

* Mon Oct 10 2016 Jan Rękorajski <baggins@pld-linux.org> 72bf0b9
- added missing modules

* Mon Oct 10 2016 Jan Rękorajski <baggins@pld-linux.org> ee2a962
- more files updates

* Mon Oct 10 2016 Jan Rękorajski <baggins@pld-linux.org> de7ed10
- updated files

* Mon Oct 10 2016 Jan Rękorajski <baggins@pld-linux.org> 8efb93e
- up to 2.8.2

* Mon Jun 06 2016 Jan Rękorajski <baggins@pld-linux.org> 11a6b97
- up to 2.8.0

* Fri Apr 08 2016 Jakub Bogusz <qboosh@pld-linux.org> e7a631b
- updated to 2.7.2

* Sun Jan 24 2016 Jan Rękorajski <baggins@pld-linux.org> 92b5818
- up to 2.7.1

